#pragma once

namespace halpp {

	template <typename TTim> class TTimerTraits {
	public:
		typedef unsigned int pulse_t;
	};

	typedef enum {
		Normal,
		Inverse
	} PwmPolarity;

	template <typename TTim, int Ch> class TPwmChannelTraits {
		typedef typename TTimerTraits<TTim>::pulse_t pulse_t;
	public:
		static void SetPulse(TTim& tim, pulse_t value) {
		}
	};

	template <typename TTim>

	template <typename TTim, typename TTraits> class TPwmChannel {
		typedef typename TTraits::pulse_t pulse_t;
	private:
		TTim& m_tim;

		// deny copy constructor
		explicit TPwmChannel(const TPwmChannel<TTim,TTraits>& self);
	public:

		TPwmChannel(TTim& tim): m_tim(tim) {
		}

		void SetPulse(pulse_t value) {
			TTraits::SetPeriod(m_tim, value);
		}

		void Enable() {
		}

		void Disable() {
		}
	};

}

